 /*
 Game for CPC464 The Great Battles of Magistar, based on North & South.>
   Copyright (C) 2016 Shirkamdev Xnetrix 

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software Foundation,
   Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
   */


#include "ai_methods.h"

/*
	Cada X tiempo random (1-5 sec) IA suelta unidad
	Si el enemigo no tiene unidades, se soltará
	en cualquier lugar del mapa, si el enemigo tiene
	unidades, entonces se elegirá aleatoriamente entre
	soltarlo en cualquier sitio del mapa o soltarlo
	dentro del rango de visión de cualquier unidad enemiga
*/

/*
	VISIBLE RANGE: 
		x: without restriction
		y: your position +- unit.height*5
	ENEMY DETECTION:
		Everyone in visible range is detected.
	PATH CHOOSE
		Look fot the closest enemy, if any, then choose to attack it, flee, or go
			to the end of the map.
*/

	//------------------------------
	//-- CALCULE LIFE AFTER FIGHT -- 
	//------------------------------

void calcularVida(TGenericUnit* u1, TGenericUnit* u2, u8 vencible){//u1 -> aliado
	if(u1->lifeUnit <= 25){
		if(u2->lifeUnit <= 25){
			if(vencible){ // gana u1
				u1->lifeUnit -= 5;
				u2->lifeUnit -= 25;
			}
			else if(!vencible){
				u1->lifeUnit -= 25;
				u2->lifeUnit -= 5;
			}
			else{
				u1->lifeUnit -= 10;
				u2->lifeUnit -= 10;
			}
		}
		else if(u2->lifeUnit <= 50){
			if(vencible){
				u1->lifeUnit -= 15;
				u2->lifeUnit -= 25;
			}
			else if(!vencible){
				u1->lifeUnit -= 50;
				u2->lifeUnit -= 5;
			}
			else{
				u1->lifeUnit -= 25;
				u2->lifeUnit -= 10;
			}
		}
		else{
			if(vencible){
				u1->lifeUnit -= 25;
				u2->lifeUnit -= 25;
			}
			else if(!vencible){
				u1->lifeUnit -= 100;
				u2->lifeUnit -= 5;
			}
			else{
				u1->lifeUnit -= 50;
				u2->lifeUnit -= 10;
			}	
		}
	}
	else if(u1->lifeUnit <= 50){
		if(u2->lifeUnit <= 25){
			if(vencible){
				u1->lifeUnit -= 5;
				u2->lifeUnit -= 50;
			}
			else if(!vencible){
				u1->lifeUnit -= 25;
				u2->lifeUnit -= 15;
			}
			else{
				u1->lifeUnit -= 10;
				u2->lifeUnit -= 25;
			}
		}
		else if(u2->lifeUnit <= 50){
			if(vencible){
				u1->lifeUnit -= 15;
				u2->lifeUnit -= 50;
			}
			else if(!vencible){
				u1->lifeUnit -= 50;
				u2->lifeUnit -= 15;
			}
			else{
				u1->lifeUnit -= 25;
				u2->lifeUnit -= 25;
			}
		}
		else{
			if(vencible){
				u1->lifeUnit -= 25;
				u2->lifeUnit -= 50;
			}
			else if(!vencible){
				u1->lifeUnit -= 100;
				u2->lifeUnit -= 15;
			}
			else{
				u1->lifeUnit -= 50;
				u2->lifeUnit -= 25;
			}
		}
	}
	else{
		if(u2->lifeUnit <= 25){
			if(vencible){
				u1->lifeUnit -= 5;
				u2->lifeUnit -= 100;
			}
			else if(!vencible){
				u1->lifeUnit -= 25;
				u2->lifeUnit -= 25;
			}
			else{
				u1->lifeUnit -= 10;
				u2->lifeUnit -= 50;
			}
		}
		else if(u2->lifeUnit <= 50){	
			if(vencible){
				u1->lifeUnit -= 15;
				u2->lifeUnit -= 100;
			}
			else if(!vencible){
				u1->lifeUnit -= 50;
				u2->lifeUnit -= 25;
			}
			else{
				u1->lifeUnit -= 25;
				u2->lifeUnit -= 50;
			}
		}
		else{
			if(vencible == 1){
				//cpct_drawStringM0("aliado gana", CPCT_VMEM_START, 5, 7);
				u1->lifeUnit -= 25;
				u2->lifeUnit -= 100;
			}
			else if(vencible == 0){
				//cpct_drawStringM0("aliado pierde", CPCT_VMEM_START, 5, 7);
				u1->lifeUnit -= 100;
				u2->lifeUnit -= 25;
			}
			else if(vencible == 2){
				//cpct_drawStringM0("iguales", CPCT_VMEM_START, 5, 7);
				u1->lifeUnit -= 50;
				u2->lifeUnit -= 50;
			}
		}
	}
}


	//------------------------------
	//-- LOOK FOR VISIBLE ENEMIES -- 
	//------------------------------
/*
u8 distanciaEnemigo(TGenericUnit* unit, TGenericUnit* start, TGenericUnit* end,
	u8 distClosest, TGenericUnit* closestUnit){
	while(start != end) {
		if(isInVisibleRange(unit, start)) {
			if(closestUnit == NULL){
				closestUnit = start;
				distClosest = (closestUnit->x - unit->x) 
					+ (closestUnit->y - unit->y);
			}
			else {
				//calculating euclidean distance
				u8 distancia = (start->x - unit->x) + (start->y - unit->y);
				if(distancia < distClosest) {
					closestUnit = start;
					distClosest = (closestUnit->x - unit->x) 
					+ (closestUnit->y - unit->y);
				}
			}
		}
		++start;
	}
	return distClosest;
}
*/

u8 distanciaEnemigo(TGenericUnit* unit, TGenericUnit* start, TGenericUnit* end){
	u8 atacar = 0;

	while(start != end){
		if(start->lifeUnit > 0 && start->fainted == NO && start->sprite != NULL){
			if(start->x > unit->x){ 
				if(start->x - unit->x == G_WARRIORENEMY_W && start->y == unit->y){//unit aliado	
					estadoAtacar(unit, start);
					atacar = 1;
				}
			}
		}
		++start;
	}
	return atacar;
}

	//--------------------------------
	//-- CHANGING STATE OF THE UNIT --
	//--------------------------------

void cambioEstado(TGenericUnit* unit, TGenericUnit* start, u8 cambio){
	u8 vencible = 0;
	if(cambio && unit->state == atacar && start->state == atacar){
		vencible = enemigoVencible(unit, start);
		if(vencible == 1 || vencible == 2) {
			estadoAtacar(unit, start);
			//unit->sprite = g_units_basic_0;
		}
		else {
			//not vincible enemy
			start->state = andar;
			unit->state = retirada;
			//unit->sprite = g_units_basic_1;
		}
	}
	else {
		//if there isn't a near unit
		//still walking
		unit->state = andar;
		//unit->sprite = g_units_basic_2;
	}
}


void estadoAndar(TGenericUnit* unit) __z88dk_fastcall{
	TGenericUnit* start; //iterador
	TGenericUnit* end; //final del array
	u8 cambio = 0;

	if(unit->playerUnit) { //Unit of the player
		start = enemyUnits;
		end = enemyUnits+MAX_UNITS;
		cambio = distanciaEnemigo(unit, start, end); //1 está en rango, 0 no
		cambioEstado(unit, start, cambio);
		moverDerecha(unit);
	}
	else {
		start = allyUnits;
		end = allyUnits+MAX_UNITS;
		moverIzquierda(unit);
	}
}



void estadoAtacar(TGenericUnit* unit, TGenericUnit* start){
	u8 vencible = 0;
	u8 atacado = 0;

	vencible = enemigoVencible(unit, start);
	calcularVida(unit, start, vencible);
	cambioEstado(unit, start, 0);
}

/*
void estadoRetirada(TGenericUnit* unit) __z88dk_fastcall{
	TGenericUnit* start;
	TGenericUnit* end;
	TGenericUnit* closestUnit = NULL; //0x0 == NULL in our program
	u8 distClosest=255;
	
	if(unit->playerUnit) { //Unit of the player
		start = enemyUnits;
		end = enemyUnits+MAX_UNITS;
		distClosest = distanciaEnemigo(unit, start, end, distClosest, closestUnit);
		cambioEstado(unit, distClosest, closestUnit);
		moverDerecha(unit);

		if(closestUnit->y < unit->y) {
			moveDown(unit);
		}
		else {
			moveUp(unit);
		}
	}
	else {
		start = allyUnits;
		end = allyUnits+MAX_UNITS;
		distClosest = distanciaEnemigo(unit, start, end, distClosest, closestUnit);
		cambioEstado(unit, distClosest, closestUnit);
		moverIzquierda(unit);

		if(closestUnit->y < unit->y) {
			moveDown(unit);
		}
		else {
			moveUp(unit);
		}
	}
}*/

void estadoEncontrarCamino(TGenericUnit* unit) __z88dk_fastcall{
	//TODO Revisar esto
}

void calculateMovement(TGenericUnit* unit) __z88dk_fastcall{
	switch(unit->state) {
		case andar:
			estadoAndar(unit);
			break;
		/*case atacar:
			estadoAtacar(unit);
			break;*/
			/*
		case defensivo:
			estadoDefensivo(unit);
			break;
			*/
		/*case retirada:
			estadoRetirada(unit);
			break;*/
			/*
		case encontrarCamino:
			estadoEncontrarCamino(unit);
			break;
			*/
	}
}


void conditionsToAddEnemy(){
	TGenericUnit* start = enemyUnits;
	TGenericUnit* end = enemyUnits + MAX_UNITS;
	TGenericUnit* startAlly = allyUnits;
	TGenericUnit* endAlly = allyUnits + MAX_UNITS;
	u8 added = 0;

	while(start != end && !added){ //Comprueba el vector de unidades actuales para la vida = 0, que ha llegado al final del mapa etc
		if(start->lifeUnit <= 0 && start->sprite != NULL && start->fainted == NO){//muere unidad en batalla
			start->fainted = SI;
			added = addEnemyUnit();
		}
		else if(start->x == 0 && start->sprite != NULL && start->fainted == NO){
			start->fainted = SI;
			added = addEnemyUnit();
		}
		while(startAlly != endAlly && !added){
			if(startAlly->x == LIMITE_DERECHA && startAlly->sprite != NULL && startAlly->fainted == NO){
				startAlly->fainted = SI;
				added = addEnemyUnit();
			}
			startAlly++;
		}
		start++;
	}
}

