 /*
 Game for CPC464 The Great Battles of Magistar, based on North & South.>
   Copyright (C) 2016 Shirkamdev Xnetrix 

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software Foundation,
   Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
   */

#include "auxiliar_methods.h"

u8 enemigoVencible(TGenericUnit* u1, TGenericUnit* u2) {
	switch(u1->type) {
		case infanteria:
			switch(u2->type) {
				case infanteria:
					return 2; //2 neutral, misma unidad
					break;
				case caballeria:
					return 1; //1 infantería gana caballería
					break;
				case artilleria:
					return 0; //0 infantería pierde artillería
					break;
			}
			break;
		case caballeria:
			switch(u2->type) {
				case infanteria:
					return 0;
					break;
				case caballeria:
					return 2;
					break;
				case artilleria:
					return 1;
					break;
			}
			break;
		case artilleria:
			switch(u2->type) {
				case infanteria:
					return 1;
					break;
				case caballeria:
					return 0;
					break;
				case artilleria:
					return 2;
					break;
			}
			break;
	}
	return 0;
}

u8 isInVisibleRange(TGenericUnit* u1, TGenericUnit* u2) {
	if((u1->x > u2->x) 
		&& (u2->y > (u1->y - VISION_LIMIT_Y)) 
		&& (u2->y < (u1->y + VISION_LIMIT_Y))) {
		return 1;
	}
	else {
		return 0;
	}
}

u8 totalPuntos;

void puntuacion(TGenericUnit* unit) __z88dk_fastcall{
	//Caballería x1/2, Infantería x1, Artillería x2 atr
	if(unit->type == caballeria){
		if(unit->lifeUnit <= 25 && unit->lifeUnit > 0){
			totalPuntos += 1;
		}
		else if(unit->lifeUnit <= 50 && unit->lifeUnit > 25){
			totalPuntos += 3;
		}
		else if(unit->lifeUnit < 100 && unit->lifeUnit > 50){
			totalPuntos += 4;
		}
		else{
			totalPuntos += 5;
		}
	}
	else if(unit->type == infanteria){
		if(unit->lifeUnit <= 25 && unit->lifeUnit > 0){
			totalPuntos += 3;
		}
		else if(unit->lifeUnit <= 50 && unit->lifeUnit > 25){
			totalPuntos += 5;
		}
		else if(unit->lifeUnit < 100 && unit->lifeUnit > 50){
			totalPuntos += 8;
		}
		else{
			totalPuntos += 10;
		}
	}
	else{
		if(unit->lifeUnit <= 25 && unit->lifeUnit > 0){
			totalPuntos += 5;
		}
		else if(unit->lifeUnit <= 50 && unit->lifeUnit > 25){
			totalPuntos += 10;
		}
		else if(unit->lifeUnit < 100 && unit->lifeUnit > 50){
			totalPuntos += 15;
		}
		else{
			totalPuntos += 20;
		}
	}
}