 /*
 Game for CPC464 The Great Battles of Magistar, based on North & South.>
   Copyright (C) 2016 Shirkamdev Xnetrix 

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software Foundation,
   Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
   */
#include "cursor_methods.h"

void moveCursor() {
	static u8 key_pressed= 0;
	u8* leftAllyUnitsPointer = leftAllyUnits;

	cpct_scanKeyboard_f();

	if(cpct_isAnyKeyPressed()) {
		if(cpct_isKeyPressed(Key_F8) || cpct_isKeyPressed(Key_CursorUp)) {
			//Mover hacia arriba
			if(!key_pressed) {
				moveCursorUp();
				cursor.moved = 1;
				key_pressed = 1;
			}
		}
		else if(cpct_isKeyPressed(Key_F2) || cpct_isKeyPressed(Key_CursorDown)) {
			//Mover hacia abajo
			if(!key_pressed) {
				moveCursorDown();
				cursor.moved = 1;
				key_pressed = 1;
			}
		}
		else if(cpct_isKeyPressed(Key_Space)) {
			//Ponemos la unidad.
			if(!key_pressed) {
				cursor.moved = 1;
				key_pressed = 1;


				if(*(leftAllyUnitsPointer+selectedAllyUnitType)) {
					addAllyUnit(CURSOR_X_POS, cursor.y+1, selectedAllyUnitType);
				}
			}
		}
		else if(cpct_isKeyPressed(Key_1)) {
			//Select unit 1
			if(!key_pressed) {
				key_pressed = 1;
				selectedAllyUnitType = 0;
			}
		}
		else if(cpct_isKeyPressed(Key_2)) {
			//Select unit 2
			if(!key_pressed) {
				key_pressed = 1;
				selectedAllyUnitType = 1;
			}
		}
		else if(cpct_isKeyPressed(Key_3)) {
			//Select unit 3
			if(!key_pressed) {
				key_pressed = 1;
				selectedAllyUnitType = 2;
			}
		}
		else {
			key_pressed = 0;
		}
	}
	else {
		key_pressed = 0;
	}
	

	if(cursor.moved) {
		borrarCursor();
		drawUnits();
		drawCursor();
		cursor.moved = 0;
	}
}

void moveCursorDown() {
	if(cursor.y <= 152) {
		cursor.py = cursor.y;
		cursor.y += 12;
	}
}

void moveCursorUp() {
	if(cursor.y >= 68) {
		cursor.py = cursor.y;
		cursor.y -= 12;
	}
}