 /*
 Game for CPC464 The Great Battles of Magistar, based on North & South.>
   Copyright (C) 2016 Shirkamdev Xnetrix 

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software Foundation,
   Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
   */
#ifndef _DEFINITIONS_H_
#define _DEFINITIONS_H_

#include <cpctelera.h>

#include "sprites/warriorEnemy.h"
#include "sprites/warriorAlly.h"
#include "sprites/archerEnemy.h"
#include "sprites/archerAlly.h"
#include "sprites/horseEnemy.h"
#include "sprites/horseAlly.h"
#include "sprites/cursor.h"
#include "sprites/banner_game.h"
#include "sprites/menu.h"
#include "sprites/tiles_2.h"

#include "maps/map_1.h"
#include "maps/map_2.h"
#include "maps/map_3.h"

#include "music/soundtrack.h"

#define ORIGEN_MAPA_X 0
#define ORIGEN_MAPA_Y 32
#define ORIGEN_MAPA cpctm_screenPtr(CPCT_VMEM_START, 0, 32)
#define DRAW_WINNER cpctm_screenPtr(CPCT_VMEM_START, 30, 44)
#define LIMITE_MAPA 80
#define LIMITE_DERECHA LIMITE_MAPA - G_WARRIORENEMY_W
#define LIMITE_MAPA_Y 200
#define LIMITE_BAJO LIMITE_MAPA_Y - G_WARRIORENEMY_00_H 
#define MAX_UNITS 6
#define VISION_LIMIT_Y G_WARRIORENEMY_H * 5
#define MAX_UNIT_DISTANCE G_WARRIORENEMY_W * 2 * 5 //Distancia importante para Pathfinding
#define NULL 0x0
#define CURSOR_X_POS 8
#define CURSOR_TILE_X_POS CURSOR_X_POS / 4
#define CURSOR_X_TILE_SIZE G_CURSOR_0_W /2
#define NUMBER_OF_UNIT_TYPES 3
#define SI 1
#define NO 0

#define RED cpct_px2byteM0 (6, 6)
//#define RED 0xAA

//extern struct Character;
//typedef struct Character TCharacter;

typedef struct {
	u8 y;
	u8 py;
	u8* sprite;
	u8 moved;
} TCursor;

typedef enum {
	infanteria,
	caballeria,
	artilleria
} unitType;

typedef enum {
	andar,
	atacar,
	defensivo,
	retirada,
	encontrarCamino
} unitState;

typedef struct {
   u8  mira;
   u8* sprite;
} TFrame;

typedef struct {
	u8 x, y;
	u8 px, py;
	unitState state;
	u8* sprite;
	unitType type;
	u8 playerUnit; //If 1, the unit is of the player
	u8 lifeUnit; //0-100
	u8 fainted;
} TGenericUnit;

typedef struct {
	u8 x, y;
} TCoordinate;

// Mirando hacia
typedef enum {
      M_derecha   = 0
   ,  M_izquierda
} EMirar;

// Eventos del personaje
typedef enum {
      EV_detenerse = 0
   ,  EV_moverse
   ,  EV_saltar
   ,  EV_numEventos
} EEventos;

extern TGenericUnit allyUnits[MAX_UNITS];
extern TGenericUnit enemyUnits[MAX_UNITS];

//Specifies how many units has the player left to place in game
//0: infantry; 1: horseman; 2: artillery
extern u8 leftAllyUnits[NUMBER_OF_UNIT_TYPES]; 
//Specifies how many units has the AI left to place in game
//0: infantry; 1: horseman; 2: artillery
extern u8 leftEnemyUnits[NUMBER_OF_UNIT_TYPES];
//Specifies which unit has selected the player to place
extern u8 selectedAllyUnitType;

extern u8* mapa;
extern TCursor cursor;
extern u8 totalPuntos;
extern u8 puntosAlly, puntosEnemy;
extern u8 rendirse;

#endif