 /*
 Game for CPC464 The Great Battles of Magistar, based on North & South.>
   Copyright (C) 2016 Shirkamdev Xnetrix 

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software Foundation,
   Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
   */
#include "graphic_methods.h"

//Creamos una mascara de transparencia
cpctm_createTransparentMaskTable(g_tablatrans, 0x600, M0, 0);

static u8 g_MAPA_ACTUAL_W=0;
static u8 g_MAPA_ACTUAL_H=0;

void redibujarUnit(TGenericUnit* start) __z88dk_fastcall{
	u8 w, h;

	if(start->type == caballeria){
		w = 5 + (start->px & 1);
		h = 5 + (start->py & 3 ? 1 : 0);
	}
	else{
		w = 5 + (start->px & 1);
		h = 8 + (start->py & 3 ? 1 : 0);
	}

	cpct_etm_drawTileBox2x4((start->px - ORIGEN_MAPA_X)/ 2, 
			(start->py - ORIGEN_MAPA_Y)/ 4, 
			w, h, g_MAPA_ACTUAL_W, ORIGEN_MAPA, mapa);
}

void borrarUnits() {
	TGenericUnit* start = allyUnits;
	TGenericUnit* end	= start+MAX_UNITS;

	while(start != end) {
		if(!unidadMuerta(start)){
			redibujarUnit(start);
		}
		++start;
	}

	start = enemyUnits;
	end = start+MAX_UNITS;

	while(start != end) {
		if(!unidadMuerta(start)){
			redibujarUnit(start);
		}
		++start;
	}
}

void drawVideoMem(TGenericUnit* start) __z88dk_fastcall{
	u8* pvmem;
	pvmem = cpct_getScreenPtr(CPCT_VMEM_START, start->x, start->y);

	switch(start->playerUnit){
		case 0:
			if(start->type == caballeria){
				cpct_drawSpriteMaskedAlignedTable (start->sprite, pvmem,  G_HORSEENEMY_W,  G_HORSEENEMY_H, g_tablatrans);
			}
			else{ //Ya que arquero y guerrero miden lo mismo
				cpct_drawSpriteMaskedAlignedTable (start->sprite, pvmem,  G_WARRIORENEMY_W,  G_WARRIORENEMY_H, g_tablatrans);
			}
			break;
		case 1:
			if(start->type == caballeria){
				cpct_drawSpriteMaskedAlignedTable (start->sprite, pvmem,  G_HORSEALLY_W,  G_HORSEALLY_H, g_tablatrans);
			}
			else{
				cpct_drawSpriteMaskedAlignedTable (start->sprite, pvmem,  G_WARRIORALLY_W,  G_WARRIORALLY_H, g_tablatrans);
			}
			break;
	}
}

void drawUnits() {
	TGenericUnit* start = allyUnits;
	TGenericUnit* end = allyUnits+MAX_UNITS;
	while(start != end) {
		if(start->lifeUnit > 0 && start->fainted == NO && start->sprite != NULL){
			drawVideoMem(start);
		}
		++start;
	}

	start = enemyUnits;
	end = enemyUnits+MAX_UNITS;

	while(start != end) {
		if(start->lifeUnit > 0 && start->fainted == NO && start->sprite != NULL){
			drawVideoMem(start);
		}
		++start;
	}
}
/*
void atacar_entrar(TGenericUnit* start) {
   start->state = atacar;
   start->mover  = SI;
}
// andando = estadoAndar
// ejecutarEstado = calculateMovement
void andando_entrar(u8 mirar, TGenericUnit* start) {
	start->nframe = 0;
 	start->state = andar;
	start->mira   = mirar;
	start->mover  = SI;	
}
//ANIM_PAUSA es el tiempo de la animación
//ANDAR_FRAMES son los sprites de andar que tenemos
void andando_animar(u8 mirar, TGenericUnit* start) { 
   start->mira  = mirar;
   if(++start->nframe == ANDAR_FRAMES*ANIM_PAUSA)
      start->nframe = 0;
}
void asignarFrame(TFrame **animacion, TGenericUnit* start) {
   start->frame = animacion[start->nframe / ANIM_PAUSA];
}
void seleccionarSpriteUnit(TGenericUnit* start) {
   switch(start->state) {
      //case ST_quieto:      { prota.frame = ;  break; }
      case andar: { start->frame = &g_frames[0];    break; }
      //case ST_prepSalto:   { asignarFrame(anim_saltar);   break; }
      //case ST_saltando:    { prota.frame = &g_frames[12]; break; }
      //case ST_cayendo:     { prota.frame = &g_frames[13]; break; }
      //case ST_aterrizando: { asignarFrame(anim_caer);     break; }
   }
   start->mover = SI;
   //girarFrame();
}
*/


/*void drawMap() {
	 cpct_etm_drawTilemap2x4(g_tilemap_W, g_tilemap_H, ORIGEN_MAPA, mapa);
}*/

void drawMap(u8 selectedMap) __z88dk_fastcall{
	cpct_clearScreen(0);
	switch(selectedMap) {
		case 1:
			mapa = g_map_1;
			g_MAPA_ACTUAL_W = g_map_1_W;
			g_MAPA_ACTUAL_H = g_map_1_H;
			cpct_etm_drawTilemap2x4(g_map_1_W, g_map_1_H, ORIGEN_MAPA, mapa);
			break;
		case 2:
			mapa = g_map_2;
			g_MAPA_ACTUAL_W = g_map_3_W;
			g_MAPA_ACTUAL_H = g_map_3_H;
			cpct_etm_drawTilemap2x4(g_map_2_W, g_map_2_H, ORIGEN_MAPA, mapa);
			break;
		case 3:
			mapa = g_map_3;
			g_MAPA_ACTUAL_W = g_map_3_W;
			g_MAPA_ACTUAL_H = g_map_3_H;
			cpct_etm_drawTilemap2x4(g_map_3_W, g_map_3_H, ORIGEN_MAPA, mapa);
			break;
		default:
			mapa = g_map_1;
			g_MAPA_ACTUAL_W = g_map_1_W;
			g_MAPA_ACTUAL_H = g_map_1_H;
			cpct_etm_drawTilemap2x4(g_map_1_W, g_map_1_H, ORIGEN_MAPA, mapa);
	}
}

void drawCursor() {
	u8* pvmem;
	pvmem = cpct_getScreenPtr(CPCT_VMEM_START, CURSOR_X_POS, cursor.y);
	//cpct_drawSprite (cursor.sprite, pvmem, G_CURSOR_0_W, G_CURSOR_0_H);
	cpct_drawSpriteMaskedAlignedTable(cursor.sprite, pvmem, G_CURSOR_0_W, G_CURSOR_0_H, g_tablatrans);
}

void borrarCursor() {
	u8 h;
	//h = 7 + (start->py & 3 ? 1 : 0);
	h = 6 + (cursor.py & 3 ? 1 : 0);
	cpct_etm_drawTileBox2x4((CURSOR_X_POS - ORIGEN_MAPA_X)/ 2, 
		(cursor.py - ORIGEN_MAPA_Y)/ 4,
		CURSOR_X_TILE_SIZE, h, g_MAPA_ACTUAL_W, ORIGEN_MAPA, mapa);
}

void drawBanner() {
	u8* pvmem;
	pvmem = cpctm_screenPtr(CPCT_VMEM_START, 0, 0);
	cpct_drawSprite (g_banner_game_0, pvmem, G_BANNER_GAME_0_W, G_BANNER_GAME_0_H);
	pvmem = cpctm_screenPtr(CPCT_VMEM_START, G_BANNER_GAME_0_W, 0);
	cpct_drawSprite (g_banner_game_1, pvmem, G_BANNER_GAME_1_W, G_BANNER_GAME_1_H);
}

void drawPoint(TCoordinate* c) __z88dk_fastcall{
	u8* pvmem = cpctm_screenPtr(CPCT_VMEM_START, c->x, c->y);
	cpct_drawSolidBox(pvmem, RED, 2, 2);
}

void drawMenu() {
	u8* pvmem;
	pvmem = cpctm_screenPtr(CPCT_VMEM_START, 0, 0);
	cpct_drawSprite (g_menu_0, pvmem, G_MENU_0_W, G_MENU_0_H);
	pvmem = cpctm_screenPtr(CPCT_VMEM_START, G_MENU_0_W, 0);
	cpct_drawSprite (g_menu_1, pvmem, G_MENU_1_W, G_MENU_1_H);
}

void drawWinner(u8 winner) __z88dk_fastcall{
	if(winner == 1) {
		cpct_drawStringM0("Player wins!", DRAW_WINNER, 7, 15);
	}
	else if(winner == 2){
		cpct_drawStringM0("AI wins!", DRAW_WINNER, 7, 15);
	}
	else {
		cpct_drawStringM0("DRAW!", DRAW_WINNER, 7, 15);
	}
}