 /*
 Game for CPC464 The Great Battles of Magistar, based on North & South.>
   Copyright (C) 2016 Shirkamdev Xnetrix 

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software Foundation,
   Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
*/

#include "definitions.h"
#include "graphic_methods.h"
#include "ai_methods.h"
#include "cursor_methods.h"
#include "game_system_methods.h"

TGenericUnit allyUnits[MAX_UNITS];
TGenericUnit enemyUnits[MAX_UNITS];
u8 leftAllyUnits[NUMBER_OF_UNIT_TYPES];
u8 leftEnemyUnits[NUMBER_OF_UNIT_TYPES];
u8 selectedAllyUnitType;
u8* mapa;
TCursor cursor;
u8 puntosAlly=0, puntosEnemy=0;
TCoordinate currentAllyPointDraw, currentEnemyPointDraw;

u8 selectedMap = 0;
u8 rendirse = 0;

u16 firmwarePointer;

// ----------
// -- MENU --
// ----------

void menu() {
	u8 pressed = 0;
	cpct_clearScreen(0);

	drawMenu();	

	do {
		cpct_scanKeyboard_f();
		if(cpct_isAnyKeyPressed()) {
			if(cpct_isKeyPressed(Key_1)) {
				selectedMap = 1;
				pressed = 1;
			}
			else if (cpct_isKeyPressed(Key_2)) {
				selectedMap = 2;
				pressed = 1;
			}
			else if(cpct_isKeyPressed(Key_3)) {
				selectedMap = 3;
				pressed = 1;
			}
			/*else if(cpct_isKeyPressed(Key_Q)) {
				selectedMap = 0;
				pressed = 1;
			}*/
			//! (cpct_isKeyPressed(Key_Enter) || cpct_isKeyPressed(Key_Return))
		}

	} while(!pressed);
}

//-----
//-- INTERRUPT HANDLER & MUSIC
//-----

extern void play();

u8 musicinterruptIterator;
void intHandler() {
	if(++musicinterruptIterator == 6) {
		play();
		musicinterruptIterator=0;
	}
}

u8 unitInterruptIterator;
void moveUnitsInt(){
	if(++unitInterruptIterator == 2) {
		moveUnits();
		unitInterruptIterator=0;
	}
}

// ------------------------
// -- INITIALIZE METHODS --
// ------------------------
void initializeScreen() {
	cpct_disableFirmware();
	cpct_setInterruptHandler(intHandler);
	//cpct_setInterruptHandler(moveUnitsInt);
	cpct_akp_musicInit(g_soundtrack); //cpct_akp_musicInit (void* songdata)
	cpct_setVideoMode(0);
	cpct_setBorder(HW_BLACK);
	cpct_setPalette(g_palette, 16);
	cpct_etm_setTileset2x4(g_tileset);
}

void initializeUnitArray(TGenericUnit* start) {
	TGenericUnit* end = start + MAX_UNITS;

	while(start!=end) {
		start->lifeUnit=0;
		start->fainted=NO;
		start->sprite = NULL;
		++start;
	}
}

void initialize() {
	TGenericUnit* start;

	start = allyUnits;
	initializeUnitArray(start);
	start = enemyUnits;
	initializeUnitArray(start);

	totalPuntos = 0;
	puntosAlly=0;
	puntosEnemy=0;

	cursor.y = cursor.py = 68;
	cursor.sprite = g_cursor_0;

	currentAllyPointDraw.x = 33;
	currentAllyPointDraw.y = 4;
	currentEnemyPointDraw.x = 43;
	currentEnemyPointDraw.y = 4;
}	


//----------
//-- MAIN --
//----------

void main(void) {
	u8 finished = 0;
	initializeScreen();
    initialize();  
   while(1) {
   		if(selectedMap != 0) {
   			initializeGame(selectedMap);
   			//loop while game is in play
   			addEnemyUnit();
   			while (!finished && !rendirse) {
				cpct_waitVSYNC();

			   	moveCursor();
			   	conditionsToAddEnemy();
			   	//moveUnits();
			   	//borrarUnits();
			   	moveUnitsInt();//mitad de velocidad unidades
			   	finished = comprobarPuntuaciones();
			   	teRindes();

			   	drawUnits();
				borrarUnits();
				drawCursor();
			}
			comprobarWinner();
			rendirse = 0;
			finished = 0;
   		}
   		menu();
   		initialize();
   }

   //cpct_reenableFirmware(firmwarePointer);
}
