 /*
 Game for CPC464 The Great Battles of Magistar, based on North & South.>
   Copyright (C) 2016 Shirkamdev Xnetrix 

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software Foundation,
   Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
   */
#include "unit_methods.h"

void moveUnits() {
	TGenericUnit* start = allyUnits;
	TGenericUnit* end	= allyUnits+MAX_UNITS;

	while(start != end) {
		if(start->fainted == NO && start->lifeUnit > 0 && start->sprite != NULL){
			calculateMovement(start);
		}
		++start;
	}

	start = enemyUnits;
	end = enemyUnits+MAX_UNITS;

	while(start != end) {
		if(start->fainted == NO && start->lifeUnit > 0 && start->sprite != NULL){
			calculateMovement(start);
		}
		++start;
	}
}

u8 unidadMuerta(TGenericUnit* start) __z88dk_fastcall{
	u8 muerta = 0;

	if(start->fainted == SI && start->sprite != NULL && start->lifeUnit == 0){
		muerta = 1;
	}
	else if(start->fainted == NO && start->sprite == NULL && start->lifeUnit == 0){ //casilla vacia
		muerta = 2;
	}
	return muerta;
}

void addAllyUnit(u8 x, u8 y, u8 selectedUnitType) {
	TGenericUnit* start = allyUnits;
	TGenericUnit* end = allyUnits+MAX_UNITS;
	u8 unitPosed=0;

	while(start!=end && !unitPosed) {
		if(start->lifeUnit == 0 && *(leftAllyUnits + selectedUnitType) > 0){
			unitPosed = 1;

			start->x = start->px = x;
			start->y = start->py = y;
			start->state = andar;
			switch(selectedUnitType) {
				case 0:
					start->sprite = g_warriorAlly;
					start->type=infanteria;
					--*(&leftAllyUnits+0);
					break;
				case 1:
					start->sprite = g_horseAlly;
					start->type = caballeria;
					--*(&leftAllyUnits+1);
					break;
				case 2:
					start->sprite = g_archerAlly;
					start->type = artilleria;
					--*(&leftAllyUnits+2);
					break;
				default:
				start->sprite = g_warriorAlly;
				start->type=infanteria;
			}
			
			start->playerUnit = 1;
			start->lifeUnit = 100;
			start->fainted = NO;
		}
		++start;
	}
}

u8 initialiceEnemy(TGenericUnit* unit){
	u8 unitRandom, added, zonaRandomY;
	u8 positionRandomY = 0;
	u8 totalUnidades = 0; //leftEnemyUnits[0]+leftEnemyUnits[1]+leftEnemyUnits[2]
	added = 0;

	unitRandom = cpct_rand() % 2; //unidad tipo random
	zonaRandomY = (cpct_rand() % 9);
	positionRandomY = 57 + (zonaRandomY * 12);
	totalUnidades = *(leftEnemyUnits + 0) + *(leftEnemyUnits + 1) + *(leftEnemyUnits + 2);
	if(totalUnidades > 0){
		while(!added){
			if(*(leftEnemyUnits + unitRandom) > 0){
				unit->x = unit->px = LIMITE_DERECHA-1;
				unit->y= unit->py = positionRandomY;
				unit->state = andar;
				switch(unitRandom) {
					case 0:
						unit->sprite = g_warriorEnemy;
						unit->type=infanteria;
						--*(&leftEnemyUnits + 0);
						break;
					case 1:
						unit->sprite = g_horseEnemy;
						unit->type = caballeria;
						--*(&leftEnemyUnits + 1);
						break;
					case 2:
						unit->sprite = g_archerEnemy;
						unit->type = artilleria;
						--*(&leftEnemyUnits + 2);
						break;
					default:
						unit->sprite = g_warriorEnemy;
						unit->type=infanteria;
				}
				unit->playerUnit = 0;
				unit->lifeUnit = 100;
				unit->fainted = NO;
				added = 1;
			}
			else{
				if(unitRandom < 2){
					unitRandom++;
				}
			}
		}
	}
	return added;
}

u8 addEnemyUnit(){
	TGenericUnit* start = enemyUnits;
	TGenericUnit* end = enemyUnits + MAX_UNITS;
	u8 added=0;

	while(start != end && !added){ //Prioriza meter unidades en casillas vacias
		if(unidadMuerta(start) == 2){
			added = initialiceEnemy(start);
		}
		start++;
	}
	start = enemyUnits;
	while(start != end && !added){	
		if(unidadMuerta(start)){
			added = initialiceEnemy(start);
		}
		start++;
	}
	return added;		
}